#line 1 "C:/Users/Carl/Documents/Pic Projects/Pic18/FlowBoard Mini/FlowBoard Mini.c"
#line 12 "C:/Users/Carl/Documents/Pic Projects/Pic18/FlowBoard Mini/FlowBoard Mini.c"
unsigned char readbuff[64] absolute 0x500;
unsigned char writebuff[64] absolute 0x540;


char cnt;
char kk;
char i,j;
unsigned S0 = 512;
unsigned S1 = 512;
unsigned servo0 = 47704;
unsigned servo1 = 47704;
int x;
int adc5 = 0;
int adc6 = 0;
int adc7 = 0;
int adc10 = 0;
int adc12 = 0;
char set1 = 0;
char set2 = 0;
char oldSet = 0;
char s0H,s0L,s1H,s1L;



sbit LD1 at LATA0_bit;
sbit LD2 at LATA1_bit;
sbit LD1_Direction at TRISA0_bit;
sbit LD2_Direction at TRISA1_bit;

sbit T1 at RD3_bit;
sbit T2 at RD2_bit;
sbit T1_Direction at TRISD3_bit;
sbit T2_Direction at TRISD2_bit;

sbit D0 at LATD4_bit;
sbit D0_Direction at TRISD4_bit;
sbit D1 at LATD5_bit;
sbit D1_Direction at TRISD5_bit;

sbit An5_Direction at TRISE0_bit;
sbit An6_Direction at TRISE1_bit;
sbit An7_Direction at TRISE2_bit;
sbit An10_Direction at TRISB1_bit;
sbit An12_Direction at TRISB0_bit;

sbit DO0 at LATD1_bit;
sbit DO0_Direction at TRISD1_bit;
sbit DO1 at LATD0_bit;
sbit DO1_Direction at TRISD0_bit;
sbit DO2 at LATD6_bit;
sbit DO2_Direction at TRISD6_bit;
sbit DO3 at LATC0_bit;
sbit DO3_Direction at TRISC0_bit;
sbit DO4 at LATC1_bit;
sbit DO4_Direction at TRISC1_bit;

sbit DI0 at RB5_bit;
sbit DI0_Direction at TRISB5_bit;
sbit DI1 at RB4_bit;
sbit DI1_Direction at TRISB4_bit;
sbit DI2 at RB3_bit;
sbit DI2_Direction at TRISB3_bit;
sbit DI3 at RB2_bit;
sbit DI3_Direction at TRISB2_bit;
sbit DI4 at RA2_bit;
sbit DI4_Direction at TRISA2_bit;



void interrupt() {
if (TMR0IF_bit){

 TMR0IF_bit = 0;

 if (set1 ==1){
 D0 = 1;
 set1 = 0;

 TMR0H = s0H;
 TMR0L = s0L;

 }else {
 D0 = 0;
 }
 if (set2 ==1){
 D1 = 1;
 set2 = 0;

 TMR0H = s1H;
 TMR0L = S1L;

 }else {
 D1 = 0;
 }

 } else {

 USB_Interrupt_Proc();

 }
}



void InitTimer0(){
 T0CON = 0x88;
 TMR0H = 0xBA;
 TMR0L = 0x58;
 GIE_bit = 1;
 TMR0IF_bit = 0;
 TMR0IE_bit = 1;


 s0H = 0xBA;
 s0L = 0x58;
 s1H = 0xBA;
 s1L = 0x58;

}

void clear_USB_buffers()
{
 for (i=0; i<63;i++)
 {
 readbuff[i] = 0;
 writebuff[i] = 0;
 }
}

char read_button1() {
 if (Button(&PORTD, 3, 2, 0)) {
 return 1;
 } else return 0;
}

char read_button2() {
 if (Button(&PORTD, 2, 2, 0)) {
 return 2;
 } else return 0;
}

void main(){
 long cnt = 0;

 ANCON0 = 0;
 ANCON1 = 0;
 TRISD = 0;
 TRISB = 0;
 TRISA = 0;
 RCSTA1=1;

 ADCON0 = 0;



 T1_Direction = 1;
 T2_Direction = 1;

 LD1_Direction = 0;
 LD2_Direction = 0;
 LD1 = 0;
 LD2 = 0;

 D0_Direction = 0;
 D0 = 0;
 D1_Direction = 0;
 D1 = 0;

 An5_Direction = 1;
 An6_Direction = 1;
 An7_Direction = 1;
 An10_Direction = 1;
 An12_Direction = 1;

 PWM9_Init(5000);
 PWM9_Start();
 PWM10_Init(5000);
 PWM10_Start();

 InitTimer0();

 DO0 = 0 ; DO0_Direction = 0;
 DO1 = 0 ; DO1_Direction = 0;
 DO2 = 0 ; DO2_Direction = 0;
 DO3 = 0 ; DO3_Direction = 0;
 DO4 = 0 ; DO4_Direction = 0;

 DI0_Direction = 1;
 DI1_Direction = 1;
 DI2_Direction = 1;
 DI3_Direction = 1;
 DI4_Direction = 1;

 clear_USB_buffers();
 HID_Enable(&readbuff,&writebuff);


 while (1){
 cnt++;

 if (cnt >200) {

 adc5 = ADC_Read(5);
 writebuff[2] = adc5 >>8;
 writebuff[3] = adc5;
 adc6 = ADC_Read(6);
 writebuff[4] = adc6>>8;
 writebuff[5] = adc6;
 adc7 = ADC_Read(7);
 writebuff[6] = adc7 >>8;
 writebuff[7] = adc7;
 adc10 = ADC_Read(10);
 writebuff[8] = adc10 >>8;
 writebuff[9] = adc10;
 adc12 = ADC_Read(12);
 writebuff[10] = adc12 >> 8;
 writebuff[11] = adc12;

 s0H = (servo0 >>8) &0xFF;
 s0L = servo0 & 0xFF;
 s1H = (servo1 >>8) & 0xFF;
 s1L = servo1 & 0xFF;

 if (oldSet == 0) {
 set1 = 1;
 oldSet = 1;
 } else {
 set2 = 1;
 oldSet = 0;
 }
 cnt = 0;
 }



 if ((readbuff[0] & 0x01 )> 0) {
 LD1 = 1;
 } else LD1 = 0;
 if ((readbuff[0] & 0x02 )> 0) {
 LD2 = 1;
 } else LD2 = 0;

 if ((readbuff[0] & 0x04 )> 0) {
 DO0 = 1;
 } else DO0 = 0;
 if ((readbuff[0] & 0x08 )> 0) {
 DO1 = 1;
 } else DO1 = 0;
 if ((readbuff[0] & 0x10 )> 0) {
 DO2 = 1;
 } else DO2 = 0;
 if ((readbuff[0] & 0x20 )> 0) {
 DO3 = 1;
 } else DO3 = 0;
 if ((readbuff[0] & 0x40 )> 0) {
 DO4 = 1;
 } else DO4 = 0;




 writebuff[0]=0;
 writebuff[0] = writebuff[0] | read_button1() ;
 writebuff[0] = writebuff[0] | read_button2() ;

 if (DI0 == 1) writebuff[0] = writebuff[0] | 0x04;
 if (DI1 == 1) writebuff[0] = writebuff[0] | 0x08;
 if (DI2 == 1) writebuff[0] = writebuff[0] | 0x10;
 if (DI3 == 1) writebuff[0] = writebuff[0] | 0x20;
 if (DI4 == 1) writebuff[0] = writebuff[0] | 0x40;

 PWM9_Set_Duty(readbuff[1]);
 PWM10_Set_Duty(readbuff[2]);


 kk = HID_Read();
 if (kk != 0)
 {
 S0 = readbuff[3] << 8;
 S0 = S0 + readbuff[4];

 servo0 = (S0 *21) + 37125;
 S1 = readbuff[5] << 8;
 S1 = S1 + readbuff[6];

 servo1 = (S1 *21) + 37125;
 HID_Write(&writebuff,64);
 }
 }
}
